<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN" "http://mybatis.org/dtd/mybatis-3-mapper.dtd" >
<mapper namespace="com.bw.adv.module.activity.mapper.ActivityActionTaskMapper" >
  <resultMap id="BaseResultMap" type="com.bw.adv.module.activity.model.ActivityActionTask" >
    <id column="ACTIVITY_ACTION_ID" property="activityActionId" jdbcType="BIGINT" />
    <result column="MEMBER_ID" property="memberId" jdbcType="BIGINT" />
    <result column="BUSINESS_CODE" property="businessCode" jdbcType="VARCHAR" />
    <result column="ACTIVITY_CODE" property="activityCode" jdbcType="VARCHAR" />
    <result column="HAPPEN_TIME" property="happenTime" jdbcType="CHAR" />
    <result column="CREATE_TIME" property="createTime" jdbcType="CHAR" />
    <result column="COUNT_TIME" property="countTime" jdbcType="CHAR" />
    <result column="IS_COUNT" property="isCount" jdbcType="CHAR" />
    <result column="COUNT_AMOUNT" property="countAmount" jdbcType="DECIMAL" />
    <result column="LANGX" property="langx" jdbcType="CHAR" />
    <result column="EXTERNAL_ID" property="externalId" jdbcType="VARCHAR" />
    <result column="RESULT_MSG" property="resultMsg" jdbcType="VARCHAR" />
  </resultMap>
  <resultMap id="ResultMapWithBLOBs" type="com.bw.adv.module.activity.model.ActivityActionTask" extends="BaseResultMap" >
    <result column="RULE_OPT_PARAMS" property="ruleOptParams" jdbcType="LONGVARCHAR" />
  </resultMap>
  <sql id="Base_Column_List" >
    ACTIVITY_ACTION_ID, MEMBER_ID, BUSINESS_CODE, ACTIVITY_CODE, HAPPEN_TIME, CREATE_TIME, 
    COUNT_TIME, IS_COUNT, COUNT_AMOUNT, LANGX, EXTERNAL_ID
  </sql>
  <sql id="Blob_Column_List" >
    RULE_OPT_PARAMS
  </sql>
  <select id="selectByPrimaryKey" resultMap="ResultMapWithBLOBs" parameterType="java.lang.Long" >
    select 
    <include refid="Base_Column_List" />
    ,
    <include refid="Blob_Column_List" />
    from activity_action_task
    where ACTIVITY_ACTION_ID = #{activityActionId,jdbcType=BIGINT}
  </select>
  <delete id="deleteByPrimaryKey" parameterType="java.lang.Long" >
    delete from activity_action_task
    where ACTIVITY_ACTION_ID = #{activityActionId,jdbcType=BIGINT}
  </delete>
  <insert id="insert" parameterType="com.bw.adv.module.activity.model.ActivityActionTask" >
    insert into activity_action_task (ACTIVITY_ACTION_ID, MEMBER_ID, BUSINESS_CODE, 
      ACTIVITY_CODE, HAPPEN_TIME, CREATE_TIME, 
      COUNT_TIME, IS_COUNT, COUNT_AMOUNT, 
      LANGX, EXTERNAL_ID, RESULT_MSG,RULE_OPT_PARAMS
      )
    values (#{activityActionId,jdbcType=BIGINT}, #{memberId,jdbcType=BIGINT}, #{businessCode,jdbcType=VARCHAR}, 
      #{activityCode,jdbcType=VARCHAR}, #{happenTime,jdbcType=CHAR}, #{createTime,jdbcType=CHAR}, 
      #{countTime,jdbcType=CHAR}, #{isCount,jdbcType=CHAR}, #{countAmount,jdbcType=DECIMAL}, 
      #{langx,jdbcType=CHAR}, #{externalId,jdbcType=VARCHAR},#{resultMsg,jdbcType=VARCHAR}, #{ruleOptParams,jdbcType=LONGVARCHAR}
      )
  </insert>
  <insert id="insertSelective" parameterType="com.bw.adv.module.activity.model.ActivityActionTask" >
    insert into activity_action_task
    <trim prefix="(" suffix=")" suffixOverrides="," >
      <if test="activityActionId != null" >
        ACTIVITY_ACTION_ID,
      </if>
      <if test="memberId != null" >
        MEMBER_ID,
      </if>
      <if test="businessCode != null" >
        BUSINESS_CODE,
      </if>
      <if test="activityCode != null" >
        ACTIVITY_CODE,
      </if>
      <if test="happenTime != null" >
        HAPPEN_TIME,
      </if>
      <if test="createTime != null" >
        CREATE_TIME,
      </if>
      <if test="countTime != null" >
        COUNT_TIME,
      </if>
      <if test="isCount != null" >
        IS_COUNT,
      </if>
      <if test="countAmount != null" >
        COUNT_AMOUNT,
      </if>
      <if test="langx != null" >
        LANGX,
      </if>
      <if test="externalId != null" >
        EXTERNAL_ID,
      </if>
      <if test="resultMsg != null" >
        RESULT_MSG,
      </if>
      <if test="ruleOptParams != null" >
        RULE_OPT_PARAMS,
      </if>
    </trim>
    <trim prefix="values (" suffix=")" suffixOverrides="," >
      <if test="activityActionId != null" >
        #{activityActionId,jdbcType=BIGINT},
      </if>
      <if test="memberId != null" >
        #{memberId,jdbcType=BIGINT},
      </if>
      <if test="businessCode != null" >
        #{businessCode,jdbcType=VARCHAR},
      </if>
      <if test="activityCode != null" >
        #{activityCode,jdbcType=VARCHAR},
      </if>
      <if test="happenTime != null" >
        #{happenTime,jdbcType=CHAR},
      </if>
      <if test="createTime != null" >
        #{createTime,jdbcType=CHAR},
      </if>
      <if test="countTime != null" >
        #{countTime,jdbcType=CHAR},
      </if>
      <if test="isCount != null" >
        #{isCount,jdbcType=CHAR},
      </if>
      <if test="countAmount != null" >
        #{countAmount,jdbcType=DECIMAL},
      </if>
      <if test="langx != null" >
        #{langx,jdbcType=CHAR},
      </if>
      <if test="externalId != null" >
        #{externalId,jdbcType=VARCHAR},
      </if>
      <if test="resultMsg != null" >
        #{resultMsg,jdbcType=VARCHAR},
      </if>
      <if test="ruleOptParams != null" >
        #{ruleOptParams,jdbcType=LONGVARCHAR},
      </if>
    </trim>
  </insert>
  
  <!-- 批量新增  -->
  <insert id="insertBatch" parameterType="java.util.List" >
    insert into activity_action_task (Activity_ACTION_ID, MEMBER_ID, BUSINESS_CODE, 
      ACTIVITY_CODE, HAPPEN_TIME, CREATE_TIME, 
      COUNT_TIME, IS_COUNT, COUNT_AMOUNT, 
      LANGX, EXTERNAL_ID, RESULT_MSG,RULE_OPT_PARAMS
      )
    values
      <foreach collection="list" item="item" index="index"  
        separator=",">
	      (#{item.activityActionId,jdbcType=BIGINT}, #{item.memberId,jdbcType=BIGINT}, #{item.businessCode,jdbcType=VARCHAR}, 
	       #{item.activityCode,jdbcType=VARCHAR}, #{item.happenTime,jdbcType=CHAR}, #{item.createTime,jdbcType=CHAR}, 
	       #{item.countTime,jdbcType=CHAR}, #{item.isCount,jdbcType=CHAR}, #{item.countAmount,jdbcType=DECIMAL}, 
	       #{item.langx,jdbcType=CHAR}, #{item.externalId,jdbcType=VARCHAR},#{item.resultMsg,jdbcType=VARCHAR}, #{item.ruleOptParams,jdbcType=LONGVARCHAR}
	      )
    </foreach>
  </insert>
  
  <update id="updateByPrimaryKeySelective" parameterType="com.bw.adv.module.activity.model.ActivityActionTask" >
    update activity_action_task
    <set >
      <if test="memberId != null" >
        MEMBER_ID = #{memberId,jdbcType=BIGINT},
      </if>
      <if test="businessCode != null" >
        BUSINESS_CODE = #{businessCode,jdbcType=VARCHAR},
      </if>
      <if test="activityCode != null" >
        ACTIVITY_CODE = #{activityCode,jdbcType=VARCHAR},
      </if>
      <if test="happenTime != null" >
        HAPPEN_TIME = #{happenTime,jdbcType=CHAR},
      </if>
      <if test="createTime != null" >
        CREATE_TIME = #{createTime,jdbcType=CHAR},
      </if>
      <if test="countTime != null" >
        COUNT_TIME = #{countTime,jdbcType=CHAR},
      </if>
      <if test="isCount != null" >
        IS_COUNT = #{isCount,jdbcType=CHAR},
      </if>
      <if test="countAmount != null" >
        COUNT_AMOUNT = #{countAmount,jdbcType=DECIMAL},
      </if>
      <if test="langx != null" >
        LANGX = #{langx,jdbcType=CHAR},
      </if>
      <if test="externalId != null" >
        EXTERNAL_ID = #{externalId,jdbcType=VARCHAR},
      </if>
      <if test="resultMsg != null" >
        RESULT_MSG = #{resultMsg,jdbcType=VARCHAR},
      </if>
      <if test="ruleOptParams != null" >
        RULE_OPT_PARAMS = #{ruleOptParams,jdbcType=LONGVARCHAR},
      </if>
    </set>
    where ACTIVITY_ACTION_ID = #{activityActionId,jdbcType=BIGINT}
  </update>
  <update id="updateByPrimaryKeyWithBLOBs" parameterType="com.bw.adv.module.activity.model.ActivityActionTask" >
    update activity_action_task
    set MEMBER_ID = #{memberId,jdbcType=BIGINT},
      BUSINESS_CODE = #{businessCode,jdbcType=VARCHAR},
      ACTIVITY_CODE = #{activityCode,jdbcType=VARCHAR},
      HAPPEN_TIME = #{happenTime,jdbcType=CHAR},
      CREATE_TIME = #{createTime,jdbcType=CHAR},
      COUNT_TIME = #{countTime,jdbcType=CHAR},
      IS_COUNT = #{isCount,jdbcType=CHAR},
      COUNT_AMOUNT = #{countAmount,jdbcType=DECIMAL},
      LANGX = #{langx,jdbcType=CHAR},
      EXTERNAL_ID = #{externalId,jdbcType=VARCHAR},
      RESULT_MSG = #{resultMsg,jdbcType=VARCHAR},
      RULE_OPT_PARAMS = #{ruleOptParams,jdbcType=LONGVARCHAR}
    where ACTIVITY_ACTION_ID = #{activityActionId,jdbcType=BIGINT}
  </update>
  <update id="updateByPrimaryKey" parameterType="com.bw.adv.module.activity.model.ActivityActionTask" >
    update activity_action_task
    set MEMBER_ID = #{memberId,jdbcType=BIGINT},
      BUSINESS_CODE = #{businessCode,jdbcType=VARCHAR},
      ACTIVITY_CODE = #{activityCode,jdbcType=VARCHAR},
      HAPPEN_TIME = #{happenTime,jdbcType=CHAR},
      CREATE_TIME = #{createTime,jdbcType=CHAR},
      COUNT_TIME = #{countTime,jdbcType=CHAR},
      IS_COUNT = #{isCount,jdbcType=CHAR},
      COUNT_AMOUNT = #{countAmount,jdbcType=DECIMAL},
      LANGX = #{langx,jdbcType=CHAR},
      EXTERNAL_ID = #{externalId,jdbcType=VARCHAR},
      RESULT_MSG = #{resultMsg,jdbcType=VARCHAR}
    where ACTIVITY_ACTION_ID = #{activityActionId,jdbcType=BIGINT}
  </update>
  
  
  <!-- 按发生时间排序查询任务活动动作	 -->
  <select id="selectByIsNotCountWithOrderByHappenTime" resultMap="ResultMapWithBLOBs" parameterType="java.lang.Integer">
   	select 
    <include refid="Base_Column_List" />
    ,
    <include refid="Blob_Column_List" />
    from activity_action_task
    where IS_COUNT = 'N'
    order by HAPPEN_TIME
    limit #{size,jdbcType=INTEGER}
  </select>
  
  
</mapper>